local beql = beql

local L = AceLibrary("AceLocale-2.2"):new("beql")

beql.options = { 
    type='group',
    args = {
		Spacing1 = {
			name = " ",
			type = "header",
			order = 19,
		},    
		qlogoption = {
			type = 'group',
			name = L["Quest Log Options"],
			desc = L["Options related to the Quest Log"],
			order = 20,
			args = {			
				Locked = {
					type = 'toggle',
					name = L["Lock Quest Log"],
					desc = L["Makes the quest log unmovable"],
					get  = function() return beql.db.profile.locked end,
					set = 'setmovable',
					order = 1
				},
				Spacing1 = {
					name = " ",
					type = "header",
					order = 2,
				},
				AlwaysMinimize = {
					type = 'toggle',
					name = L["Always Open Minimized"],
					desc = L["Force the quest log to open minimized"],
					get = function() return beql.db.profile.alwaysminimize end,
					set = function(newval) beql.db.profile.alwaysminimize = newval end,
					disabled = function() return beql.db.profile.alwaysmaximize end,
					order = 3,
				},
				AlwaysMaximize = {
					type = 'toggle',
					name = L["Always Open Maximized"],
					desc = L["Force the quest log to open maximized"],
					get = function() return beql.db.profile.alwaysmaximize end,
					set = function(newval) beql.db.profile.alwaysmaximize = newval end,
					disabled = function() return beql.db.profile.alwaysminimize end,
					order = 4,
				},
				ShowLevel = {
					type = 'toggle',
					name = L["Show Quest Level"],
					desc = L["Shows the quests level"],
					get = function() return beql.db.profile.showlevel end,
					set = function(newval) beql.db.profile.showlevel = newval QuestLog_Update() beql:ManageQuests() QuestWatch_Update() end,
					disabled = function() return beql.db.profile.disabled.showlevel end,
					order = 5,
				},
				InfoOnQuestCompletion = {
					type = 'toggle',
					name = L["Info on Quest Completion"],
					desc = L["Shows a message and plays a sound when you complete a quest"],
					get = function() return beql.db.profile.InfoOnQuestCompletion end,
					set = 'setinfoonquestcomplete',
					order = 6,
				},				  			
				AutoComplete = {
					type = 'toggle',
					name = L["Auto Complete Quest"],
					desc = L["Automatically Complete Quests"],
					get = function() return beql.db.profile.autocomplete end,
					set = function(newval) beql.db.profile.autocomplete = newval end,
					order = 7,
				},				
			},
		},
		qtrackeroption = {
			type = 'group',
			name = L["Quest Tracker Options"],
			desc = L["Options related to the Quest Tracker"],
			order = 21,
			disabled = function() return beql.db.profile.disabled.tracker end,
			args = {
				LockedTracker = {
					type = 'toggle',
					name = L["Lock Tracker"],
					desc = L["Makes the quest tracker unmovable"],
					get = function() return beql.db.profile.lockedtracker end,
					set = 'setmovabletracker',
					disabled = function() return beql.db.profile.disabled.lockedtracker end,
					order = 1,
				},
				Spacing1 = {
					name = " ",
					type = "header",
					order = 2,
				},
				ShowTrackerHeader = {
					type = 'toggle',
					name = L["Show Tracker Header"],
					desc = L["Shows the trackers header"],
					get = function() return beql.db.profile.ShowTrackerHeader end,
					set = function(newval) beql.db.profile.ShowTrackerHeader = newval QuestWatch_Update() end,
					order = 3,
				},
				TrackerFontHeight = {
					type = 'range',
					name = L["Font Size"],
					desc = L["Changes the font size of the tracker"],
					get = function()
						return beql.db.profile.TrackerFontHeight
					end,
					set = function(newval)
						beql.db.profile.TrackerFontHeight = newval
						QuestWatch_Update()
					end,
					min = 8,
					max = 18,
					step = 1,
					order = 4,
				},	
				Spacing2 = {
					name = " ",
					type = "header",
					order = 5,
				}, 
				AddNew = {
					type = 'toggle',
					name = L["Add New Quests"],
					desc = L["Automatical add new Quests to tracker"],
					get = function() return beql.db.profile.AddNew end,
					set = function(newval) beql.db.profile.AddNew = newval QuestWatch_Update() end,
					order = 6,
				},
				AddUntracked = {
					type = 'toggle',
					name = L["Add Untracked"],
					desc = L["Automatical add quests with updated objectives to tracker"],
					get = function() 
						if AUTO_QUEST_WATCH == "1" then
							return true
						else
							return false
						end
					end,
					set = function(newval) 
						if newval then
							AUTO_QUEST_WATCH = "1"
						else
							AUTO_QUEST_WATCH = "0"
						end
						QuestWatch_Update() 
					end,
					order = 7,
				},		
				Spacing3 = {
					name = " ",
					type = "header",
					order = 8,
				},  						

				ShowZonesInTracker = {
					type = 'toggle',
					name = L["Show Quest Zones"],
					desc = L["Show the quests zone it belongs to above its name"],
					get = function() return beql.db.profile.ShowZonesInTracker end,
					set = function(newval) beql.db.profile.ShowZonesInTracker = newval QuestWatch_Update() end,
					order = 9,
				},			
				Spacing4 = {
					name = " ",
					type = "header",
					order = 11,
				},  					
				RemoveFinished = {
					type = 'toggle',
					name = L["Remove Completed Quests"],
					desc = L["Automatical remove completed quests from tracker"],
					get = function() return beql.db.profile.RemoveFinished end,
					set = function(newval) beql.db.profile.RemoveFinished = newval QuestWatch_Update() end,
					order = 12,
				},

				MinimizeFinished = {
					type = 'toggle',
					name = L["Hide Completed Objectives"],
					desc = L["Automatical hide completed objectives in tracker"],
					get = function() return beql.db.profile.MinimizeFinished end,
					set = function(newval) beql.db.profile.MinimizeFinished = newval QuestWatch_Update() end,
					order = 13,
				},	
				SortTrackerItems = {
					type = 'toggle',
					name = L["Sort Tracker Quests"],
					desc = L["Sort the quests in tracker"],
					get = function() return beql.db.profile.SortTrackerItems end,
					set = function(newval) beql.db.profile.SortTrackerItems = newval beql:SortWatchedQuests() QuestWatch_Update() end,
					order = 15,
				},
				MarkerOptions = {
					type = 'group',
					name = L["Markers"],
					desc = L["Customize the Objective/Quest Markers"],
					order = 16,
					args = {
						ShowObjectiveMarkers = {	
							type = 'toggle',
							name = L["Show Objective Markers"],
							desc = L["Display Markers before objectives"],
							get = function() return beql.db.profile.ShowObjectiveMarkers end,
							set = function(newval) beql.db.profile.ShowObjectiveMarkers = newval QuestWatch_Update() end,
							order = 20,
						},					
						UseTrackerListing = {
							type = 'toggle',
							name = L["Use Listing"],
							desc = L["User Listing rather than symbols"],
							get = function() return beql.db.profile.UseTrackerListing end,
							set = function(newval) beql.db.profile.UseTrackerListing = newval QuestWatch_Update() end,
							disabled = function() return not beql.db.profile.ShowObjectiveMarkers end,
							order = 21,
						},	
						TrackerList = {
							type = 'range',
							name = L["List Type"],
							desc = L["Set the type of listing"],
							get = function()
								return beql.db.profile.TrackerList
							end,
							set = function(newval)
								beql.db.profile.TrackerList = newval
								QuestWatch_Update()
							end,
							min = 0,
							max = 3,
							step = 1,
							disabled = function() return not beql.db.profile.UseTrackerListing end,
							order = 22,
						},
						TrackerSymbol = {
							type = 'range',
							name = L["Symbol Type"],
							desc = L["Set the type of symbol"],
							get = function()
								return beql.db.profile.TrackerSymbol
							end,
							set = function(newval)
								beql.db.profile.TrackerSymbol = newval
								QuestWatch_Update()
							end,
							min = 0,
							max = 3,
							step = 1,
							disabled = function() return beql.db.profile.UseTrackerListing end,
							order = 23,
						},
					},
				},				
				Colors = {
					type = 'group',
					name = L["Colors"],
					desc = L["Set tracker Colors"],
					order = 17,
					args = {
						BackgroundAlpha = {
							type = 'toggle',
							name = L["Background"],
							desc = L["Use Background"],
							get = function() return beql.db.profile.BackgroundAlpha end,
							set = function(newval) beql.db.profile.BackgroundAlpha = newval QuestWatch_Update() end,
							order = 51,					
						},					
						CustomBackgroundColor = {
							type = 'toggle',
							name = L["Custom Background Color"],
							desc = L["Use custom color for background"],
							get = function() return beql.db.profile.CustomBackgroundColor end,
							set = function(newval) beql.db.profile.CustomBackgroundColor = newval QuestWatch_Update() end,
							disabled = function() return not beql.db.profile.BackgroundAlpha end,
							order = 52,
						},
						BackgroundColor = {
							type = 'color',
							name = L["Background Color"],
							desc = L["Sets the Background Color"],
							get = function() 
								return beql.db.profile.Color.BackgroundColor.r, beql.db.profile.Color.BackgroundColor.g, beql.db.profile.Color.BackgroundColor.b, beql.db.profile.Color.BackgroundColor.a
							end,
							set = function(r, g, b, a)
								beql.db.profile.Color.BackgroundColor.r = r
								beql.db.profile.Color.BackgroundColor.g = g
								beql.db.profile.Color.BackgroundColor.b = b
								beql.db.profile.Color.BackgroundColor.a = a
								QuestWatch_Update()
							end,					
							hasalpha = true,
							disabled = function() return not beql.db.profile.CustomBackgroundColor end,
							order = 53,							
						},
						BackgroundCornerColor = {
							type = 'color',
							name = L["Background Corner Color"],
							desc = L["Sets the Background Corner Color"],
							get = function() 
								return beql.db.profile.Color.BackgroundCornerColor.r, beql.db.profile.Color.BackgroundCornerColor.g, beql.db.profile.Color.BackgroundCornerColor.b, beql.db.profile.Color.BackgroundCornerColor.a
							end,
							set = function(r, g, b, a)
								beql.db.profile.Color.BackgroundCornerColor.r = r
								beql.db.profile.Color.BackgroundCornerColor.g = g
								beql.db.profile.Color.BackgroundCornerColor.b = b
								beql.db.profile.Color.BackgroundCornerColor.a = a
								QuestWatch_Update()
							end,					
							hasalpha = true,
							disabled = function() return not beql.db.profile.CustomBackgroundColor end,
							order = 54,
						},
						CustomZoneColor = {
							type = 'toggle',
							name = L["Custom Zone Color"],
							desc = L["Use custom color for Zone names"],
							get = function() return beql.db.profile.CustomZoneColor end,
							set = function(newval) beql.db.profile.CustomZoneColor = newval QuestWatch_Update() end,
							order = 55,
						},					
						ColorZone = {
							type = 'color',
							name = L["Zone Color"],
							desc = L["Sets the zone color"],
							get = function() 
								return beql.db.profile.Color.Zone.r, beql.db.profile.Color.Zone.g, beql.db.profile.Color.Zone.b, beql.db.profile.Color.Zone.a
							end,
							set = function(r, g, b, a)
								beql.db.profile.Color.Zone.r = r
								beql.db.profile.Color.Zone.g = g
								beql.db.profile.Color.Zone.b = b
								beql.db.profile.Color.Zone.a = a
								QuestWatch_Update()
							end,					
							hasalpha = false,
							disabled = function() return not beql.db.profile.CustomZoneColor end,
							order = 56,
						},
						FadeColor = {
							type = 'toggle',
							name = L["Fade Colors"],
							desc = L["Fade the objective colors"],
							get = function() return beql.db.profile.FadeColor end,
							set = function(newval) beql.db.profile.FadeColor = newval QuestWatch_Update() end,
							order = 57,
						},
						CustomObjetiveColor = {
							type = 'toggle',
							name = L["Custom Objective Color"],
							desc = L["Use custom color for objective text"],
							get = function() return beql.db.profile.CustomObjetiveColor end,
							set = function(newval) beql.db.profile.CustomObjetiveColor = newval QuestWatch_Update() end,
							order = 58,
						},							
						ColorObjectiveEmpty = {
							type = 'color',
							name = L["Objective Color"],
							desc = L["Sets the color for objectives"],
							get = function() 
								return beql.db.profile.Color.ObjectiveEmpty.r, beql.db.profile.Color.ObjectiveEmpty.g, beql.db.profile.Color.ObjectiveEmpty.b, beql.db.profile.Color.ObjectiveEmpty.a
							end,
							set = function(r, g, b, a)
								beql.db.profile.Color.ObjectiveEmpty.r = r
								beql.db.profile.Color.ObjectiveEmpty.g = g
								beql.db.profile.Color.ObjectiveEmpty.b = b
								beql.db.profile.Color.ObjectiveEmpty.a = a
								QuestWatch_Update()
							end,					
							hasalpha = false,
							disabled = function() return not beql.db.profile.CustomObjetiveColor end,
							order = 59,
						},
						ColorObjectiveComplete = {
							type = 'color',
							name = L["Completed Objective Color"],
							desc = L["Sets the color for completed objectives"],
							get = function() 
								return beql.db.profile.Color.ObjectiveComplete.r, beql.db.profile.Color.ObjectiveComplete.g, beql.db.profile.Color.ObjectiveComplete.b, beql.db.profile.Color.ObjectiveComplete.a
							end,
							set = function(r, g, b, a)
								beql.db.profile.Color.ObjectiveComplete.r = r
								beql.db.profile.Color.ObjectiveComplete.g = g
								beql.db.profile.Color.ObjectiveComplete.b = b
								beql.db.profile.Color.ObjectiveComplete.a = a
								QuestWatch_Update()
							end,					
							hasalpha = false,
							disabled = function() return not beql.db.profile.CustomObjetiveColor end,	
							order = 60,						
						},
						

						CustomHeaderColor = {
							type = 'toggle',
							name = L["Custom Header Color"],
							desc = L["Use custom color for headers"],
							get = function() return beql.db.profile.CustomHeaderColor end,
							set = function(newval) beql.db.profile.CustomHeaderColor = newval QuestWatch_Update() end,
							order = 61,
						},
						HeaderQuestLevelColor = {
							type = 'toggle',
							name = L["Use Quest Level Colors"],
							desc = L["Use the colors to indicate quest difficulty"],
							get = function() return beql.db.profile.HeaderQuestLevelColor end,
							set = function(newval) beql.db.profile.HeaderQuestLevelColor = newval QuestWatch_Update() end,
							disabled = function() return not beql.db.profile.CustomHeaderColor end,
							order = 62,
						},				
						ColorHeaderEmpty = {
							type = 'color',
							name = L["Header Color"],
							desc = L["Sets the color for headers"],
							get = function() 
								return beql.db.profile.Color.HeaderEmpty.r, beql.db.profile.Color.HeaderEmpty.g, beql.db.profile.Color.HeaderEmpty.b, beql.db.profile.Color.HeaderEmpty.a
							end,
							set = function(r, g, b, a)
								beql.db.profile.Color.HeaderEmpty.r = r
								beql.db.profile.Color.HeaderEmpty.g = g
								beql.db.profile.Color.HeaderEmpty.b = b
								beql.db.profile.Color.HeaderEmpty.a = a
								QuestWatch_Update()
							end,					
							hasalpha = false,
							disabled = function() return not beql.db.profile.CustomHeaderColor or beql.db.profile.HeaderQuestLevelColor end,	
							order = 63,
						},								
						ColorHeaderComplete = {
							type = 'color',
							name = L["Completed Header Color"],
							desc = L["Sets the color for completed headers"],
							get = function() 
								return beql.db.profile.Color.HeaderComplete.r, beql.db.profile.Color.HeaderComplete.g, beql.db.profile.Color.HeaderComplete.b, beql.db.profile.Color.HeaderComplete.a
							end,
							set = function(r, g, b, a)
								beql.db.profile.Color.HeaderComplete.r = r
								beql.db.profile.Color.HeaderComplete.g = g
								beql.db.profile.Color.HeaderComplete.b = b
								beql.db.profile.Color.HeaderComplete.a = a
								QuestWatch_Update()
							end,					
							hasalpha = false,
							disabled = function() return not beql.db.profile.CustomHeaderColor end,	
							order = 64,
						},						
					},
				},
			},
		},  
    },
}


function beql:setmovable(newValue)
	self.db.profile.locked = newValue
	if self.db.profile.locked then
		QuestLogFrame:RegisterForDrag(0)
	else
		QuestLogFrame:RegisterForDrag("LeftButton")
	end	
end


function beql:setmovabletracker(newValue)
	self.db.profile.lockedtracker = newValue
	if not self.db.profile.disabled.tracker then
		if self.db.profile.lockedtracker then
			QuestWatchFrame:RegisterForDrag(0)
			beql.TrackerTitleBar:RegisterForDrag(0)
			QuestWatchFrame:EnableMouse(false)	
		else
			QuestWatchFrame:EnableMouse(true)	
			QuestWatchFrame:RegisterForDrag("LeftButton")
			beql.TrackerTitleBar:RegisterForDrag("LeftButton")
		end
	end
end


function beql:setinfoonquestcomplete(newValue)
	self.db.profile.InfoOnQuestCompletion = newValue
	if self.db.profile.InfoOnQuestCompletion then
		beql:LookForCompletedQuests(false)
	end	
end